package space.kklochko.jdbc_hospital_example.cli.commands.factories;

import lombok.NonNull;
import space.kklochko.jdbc_hospital_example.cli.commands.CommandData;
import space.kklochko.jdbc_hospital_example.models.Department;
import space.kklochko.jdbc_hospital_example.models.Indicator;
import space.kklochko.jdbc_hospital_example.models.Patient;

import java.sql.Timestamp;
import java.util.Map;
import java.util.UUID;

public class EntityFactory {
    public Object create(@NonNull CommandData commandData) {
        if(commandData.getDatatype().equals("indicator")) {
            Map<String, String> values = commandData.getArguments();
            Timestamp timestamp = Timestamp.valueOf(values.get("timestamp"));
            Indicator indicator = new Indicator(values.get("type"), values.get("values"), timestamp);

            String uuidString = values.getOrDefault("id", null);
            if(uuidString != null) {
                UUID uuid = UUID.fromString(uuidString);
                indicator.setId(uuid);
            }

            return (Object) indicator;
        }else if(commandData.getDatatype().equals("patient")) {
            Map<String, String> values = commandData.getArguments();
            short age = Short.parseShort(values.get("age"));
            Patient patient = new Patient(values.get("name"), age, values.get("phone"));

            String uuidString = values.getOrDefault("id", null);
            if(uuidString != null) {
                UUID uuid = UUID.fromString(uuidString);
                patient.setId(uuid);
            }

            return (Object) patient;
        }else {
            Map<String, String> values = commandData.getArguments();
            Department department = new Department(values.get("name"), values.get("location"), values.get("phone"));

            String uuidString = values.getOrDefault("id", null);
            if(uuidString != null) {
                UUID uuid = UUID.fromString(uuidString);
                department.setId(uuid);
            }

            return (Object) department;
        }
    }
}
