package space.kklochko.jdbc_hospital_example.cli.validators;

import java.util.regex.Pattern;

public class CommandValidator extends Validator {
    String command;

    String formatRegEx = "(readAll|insert|update|remove)\\s(indicator|patient|department)\\(.*\\)";

    public CommandValidator(String command) {
        this.command = command;
    }

    public boolean isValid() {
        Pattern pattern = Pattern.compile(formatRegEx);
        return pattern.matcher(command).matches();
    }

    public String getMessage() {
        return "Please, check the format: `command item(arg1=value1, ...)`. Or check the `help`";
    }
}
